--This one works at load, but still needs RL for new/changed spells--
-- Disable the addon if the player is not a hunter:
if select(2, UnitClass("player")) ~= "HUNTER" then
	return DisableAddOn("EZTrap")
end
------------------------------------------------------------------------
-- Create the base frame:
local EZTrap = CreateFrame("Frame", "EZTrap", UIParent)
EZTrap:SetPoint("CENTER", -1, -144)
EZTrap:SetSize(140, 140)
-- Make it draggable and resizable:
EZTrap:SetMovable(true)
EZTrap:SetResizable(true)
EZTrap:EnableMouse(true)
EZTrap:SetMaxResize(140,140)
EZTrap:SetMinResize(70,70)
EZTrap:RegisterEvent("PLAYER_LOG_IN")
EZTrap:RegisterForDrag("RightButton", "LeftButton")
EZTrap:SetScript("OnMouseDown", function(self, button)
local shiftDown = IsShiftKeyDown();
  if button == "RightButton" and not self.isMoving then
   self:StartMoving();
   self.isMoving = true;
  elseif ( IsShiftKeyDown() ) and (button == "LeftButton" and not self.isSizing) then
   self:StartSizing();
   self.isSizing = true
  end
end)
EZTrap:SetScript("OnMouseUp", function(self, button)
  if button == "RightButton" and self.isMoving then
   self:StopMovingOrSizing();
   self.isMoving = false; 
  elseif (button == "LeftButton" and self.isSizing) then
   self:StopMovingOrSizing();
   self.isSizing = false
  end
end)
EZTrap:SetScript("OnHide", function(self)
  if ( self.isMoving ) or (self.isSizing) then
   self:StopMovingOrSizing();
   self.isMoving = false;
   self.isSizing = false;
  end
end)
-- Add the background:
EZTrap:SetBackdrop({
    bgFile = [[Interface\AddOns\EZTrap\Icon\Trap.tga]], tile = False, tileSize = 32,
	--bgFile = [[Interface\Icons\ability_ensnare]], tile = False, tileSize = 20,
	edgeFile = [[Interface\DialogFrame\UI-DialogBox-Border]], edgeSize = 32,
	insets = { left = 16, right = 17, top = 17, bottom = 16,}
})
EZTrap:SetBackdropColor(0.5,0.5,0.5,0.40)
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
-- Set up a button factory:
local CreateTrapButton
do
-- Share the same event handler function between buttons
-- instead of creating duplicate functions:
	    local function TrapButton_OnEvent(self, event, ...)
		local start, duration = GetSpellCooldown(self.spellID)
		if duration > 0 then
			self.cooldown:Show()
			self.cooldown:SetCooldown(start, duration)
		end
	end
	function CreateTrapButton(spellID)
-- Get the name and icon for the specified spell:
		local spellName, _, spellIcon = GetSpellInfo(spellID)
		if not spellName then
			-- That's not a valid spell ID!
			return
		end		
-- Create the button:
		local button = CreateFrame("Button", "$parent"..gsub(spellName, "[^%a]", ""), EZTrap, "SecureActionButtonTemplate")		
-- Set the correct trap spell properties:
		button:SetAttribute("type", "spell")
		button:SetAttribute("spell", spellName)
		button:SetNormalTexture(spellIcon)
		button.spellID = spellID
-- Add a cooldown to the button:
		local cd = CreateFrame("Cooldown", "$parentCooldown", button, "CooldownFrameTemplate")
		button.cooldown = cd
		cd:SetAllPoints(true)
		cd:Hide()
-- Update the cooldown when needed:
		button:RegisterEvent("SPELL_UPDATE_COOLDOWN")
		button:SetScript("OnEvent", TrapButton_OnEvent)
-- Hand the button back to the calling code:
		return button
	end
end
-------------------------------------------------------------------------
-------------------------------------------------------------------------
local level = UnitLevel("player")
-- Add a button for Freezing Trap:
local Freezing = CreateTrapButton(1499)
Freezing:SetPoint("TOPLEFT", EZTrap, "TOPLEFT", 10, -10)
Freezing:SetPoint("TOPRIGHT", EZTrap, "CENTER", 0, 0) 
Freezing:SetPoint("BOTTOMLEFT", EZTrap, "CENTER", 0, 6)
Freezing:SetPoint("BOTTOMRIGHT", EZTrap, "CENTER", 0, 6)
Freezing:SetSize(20, 20)
 if level < 28 then
    Freezing:Hide()
  else
    Freezing:Show()
  end
 -- Add a button for Explosive Trap:
local Explosive = CreateTrapButton(13813)
Explosive:ClearAllPoints()
Explosive:SetPoint("TOPRIGHT", EZTrap, "TOPRIGHT", -10, 0)
Explosive:SetPoint("TOPLEFT", Freezing, "TOPRIGHT", 0, 0)
Explosive:SetPoint("BOTTOMLEFT", Freezing, "BOTTOMLEFT", 0, 0)
Explosive:SetSize(20, 20)
 if level < 38 then
    Explosive:Hide()
  else
    Explosive:Show()
  end
--------------------------------------------------------------------------
-- Add a button for Flare:
local Flare = CreateTrapButton(1543)
Flare:ClearAllPoints()
Flare:SetPoint("TOPLEFT", Freezing, "BOTTOMLEFT", 3, -15)
Flare:SetPoint("BOTTOMLEFT", EZTrap, "BOTTOMLEFT", 10, 10)
Flare:SetPoint("TOPRIGHT", Freezing, "BOTTOMRIGHT", 3, 0)
Flare:SetSize(20, 20)
 if level < 38 then
    Flare:Hide()
  else
    Flare:Show()
  end
 ----------------------------------------------------------------------------------------
local z = CreateFrame("Frame", "EZListen", UIParent)
z:RegisterEvent("PLAYER_ENTERING_WORLD")
z:SetScript("OnEvent", function(self, event, ...) return self[event](self, event, ...) end)
function z:PLAYER_ENTERING_WORLD()
local Ice = CreateTrapButton(13809)
--local Ice = CreateFrame("Button", "Ice", EZTrap, "SecureActionButtonTemplate")
Ice:ClearAllPoints()
Ice:SetPoint("BOTTOMRIGHT", EZTrap, "BOTTOMRIGHT", 0, 0)
Ice:SetPoint("BOTTOMLEFT", Flare, "BOTTOMRIGHT", 0, 0)
Ice:SetPoint("TOPLEFT", Flare, "TOPRIGHT", 0, -1)
Ice:SetPoint("TOPRIGHT", Explosive, "BOTTOMRIGHT", 0, -1)
Ice:SetSize(20, 20)
Ice:SetAttribute("type", "spell")
Ice:SetAttribute("spell", "Ice Trap")
Ice:SetNormalTexture([[Interface\Icons\spell_hunter_icetrap]])
Ice:RegisterEvent("SPELLS_CHANGED")
			for i = 1, GetNumGlyphSockets() do
					_, _, _, glyphSpellID, _ = GetGlyphSocketInfo(i);
					if (glyphSpellID == 159470) or level < 46 then
						Ice:Hide()
					else
						Ice:Show()
					end
            end
--Add Snake Trap if needed
local Snake = CreateTrapButton(34600)--works
--local spellName = "Snake Trap"
local spellName, _, spellIcon = GetSpellInfo(34600)
Snake:ClearAllPoints()
Snake:SetPoint("BOTTOMRIGHT", EZTrap, "BOTTOMRIGHT", 0, 0)
Snake:SetPoint("BOTTOMLEFT", Flare, "BOTTOMRIGHT", 0, 0)
Snake:SetPoint("TOPLEFT", Flare, "TOPRIGHT", 0, -1)
Snake:SetPoint("TOPRIGHT", Explosive, "BOTTOMRIGHT", 0, -1)
Snake:SetSize(20, 20)
Snake:SetAttribute("type", "spell")
Snake:SetAttribute("spell", "Snake Trap")
Snake:SetNormalTexture(spellIcon)
--Snake:SetNormalTexture([[Interface\Icons\ability_hunter_snaketrap]])
--Snake:RegisterEvent("SPELLS_CHANGED")		
	for i = 1, GetNumGlyphSockets() do
				_, _, _, glyphSpellID, _ = GetGlyphSocketInfo(i);
				if (glyphSpellID == 159470) then
					Snake:Show()
				else
					Snake:Hide()
				end
	end
local function Snake_OnEvent(self, event, ...)
local start, duration = GetSpellCooldown(34600)
		if duration > 0 then
			self.cooldown:Show()
			self.cooldown:SetCooldown(start, duration)
		end
end
-- Add a cooldown to the button:
		local cd = CreateFrame("Cooldown", "$parentCooldown", Snake, "CooldownFrameTemplate")
		Snake.cooldown = cd
		cd:SetAllPoints(true)
		cd:Hide()
-- Update the cooldown when needed:
		Snake:RegisterEvent("SPELL_UPDATE_COOLDOWN")
		Snake:SetScript("OnEvent", Snake_OnEvent)
	function Snake:SPELLS_CHANGED()
		if event=="SPELLS_CHANGED" then 
		return Snake--
		end
    end
------------------------------------------------------------------------
-- Add a button for Trap Launcher:
local name TRAP_LAUNCHER = GetSpellInfo(77769)
local f = CreateFrame("Button", "Launcher", EZTrap, "SecureActionButtonTemplate")
f:ClearAllPoints()
f:SetPoint("CENTER",0,0)
f:SetSize(60, 20)
f:SetAttribute("type", "spell")
f:SetAttribute("spell", "Trap Launcher")
f:RegisterUnitEvent("UNIT_AURA", "player")
f:SetScript("OnEvent", function()
    local name, _, _, _, _, _, _, _, _, _, spellID = UnitBuff("player", TRAP_LAUNCHER)
   if name then
       f:SetNormalTexture([[Interface\Icons\spell_nature_wispsplode]])
   elseif not name then
       f:SetNormalTexture([[Interface\Icons\ability_hunter_traplauncher]])
   end
end)
if level < 48 then
    f:Hide()
  else
    f:Show()
  end
end
--------------------------------------------------------------